#include "stdafx.h"
#include "NToolTipMgr.h"

//static properties
int CNToolTipMgr::Prop_MaxTipWidth = 300;

CNToolTipMgr::CNToolTipMgr()
{
	::ZeroMemory(&m_Info, sizeof(TOOLINFO));
	_tcscpy(m_szText, _T(""));
	m_bVisible = TRUE;
	m_hwndParent = NULL;
	m_hwndToolTip = NULL;
	m_pToolTipCurrent = NULL;
}

CNToolTipMgr::~CNToolTipMgr()
{

}

BOOL CNToolTipMgr::_Init()
{
	// {kr} θ찡 ȿ  ٷ  {/kr}
	if(m_hwndParent == NULL) return FALSE;

	// {kr} 찡 Ǿ ٷ . {/kr}
	if (::IsWindow(m_hwndToolTip) == TRUE) return TRUE;

	// {kr} θ츦 ̿Ͽ  . {/kr}
	m_hwndToolTip = ::CreateWindowEx(	NULL,
										TOOLTIPS_CLASS,
										NULL,
										WS_POPUP | TTS_NOPREFIX,		
										CW_USEDEFAULT,
										CW_USEDEFAULT,
										CW_USEDEFAULT,
										CW_USEDEFAULT,
										m_hwndParent,
										NULL,
										_AtlBaseModule.GetModuleInstance(),
										NULL );

	
	// {kr} 찡 ߸ Ǿ ٷ  {/kr}
	if (::IsWindow(m_hwndToolTip) == FALSE) return FALSE;

	// {kr}  . Ʒ ⺻ ʱȭ. {/kr}
	m_Info.cbSize = sizeof(TOOLINFO);

	// {kr} PM-1128 {/kr}
	// {kr} ׳ :  ġ  . {/kr}
	// {kr}  : comctl32.dll  4.7 ĺʹ TTF_ABSOLUTE ÷׸ ʼ ؾ {/kr}
	// {kr}		̴ Ʈ   . {/kr}
	// {kr} ذ : TTF_ABSOLUTE ÷׸ . {/kr}
	m_Info.uFlags = TTF_IDISHWND | TTF_TRACK | TTF_ABSOLUTE;

	m_Info.hwnd = m_hwndParent;
	m_Info.hinst = _AtlBaseModule.GetModuleInstance();
	m_Info.uId = 0;
	::SendMessage(m_hwndToolTip, TTM_ADDTOOL, 0, (LPARAM)(&m_Info));

	// {kr}  ִ ̸ . {/kr}
	::SendMessage(m_hwndToolTip, TTM_SETMAXTIPWIDTH, 0, Prop_MaxTipWidth);

	return TRUE;
}

void CNToolTipMgr::Close()
{
	// {kr} 찡 ȿϴٸ {/kr}
	if (::IsWindow(m_hwndToolTip) == TRUE)
	{
		// {kr}	 ı {/kr}
		::DestroyWindow(m_hwndToolTip);
	}
	
	// {kr} 츦 ΰ ʱȭ. {/kr}
	m_hwndToolTip = NULL;
}

void CNToolTipMgr::SetText( LPCTSTR szText )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(_tcslen(szText) >= 0);
	if(!(_tcslen(szText) >= 0)) return;
	
	// {kr}  lazy iniitialize {/kr}
	BOOL bResult = this->_Init();
	// {kr} ϸ ٷ . {/kr}
	if (bResult == FALSE) return;

	// {kr} Ű Էµ ؽƮ ٸ 쿡 {/kr}
	if (_tcscmp(szText, m_szText) != 0)
	{
		// {kr} ؽƮ   ؽƮ . {/kr}
		_tcscpy(m_szText, szText);
		// {kr} ü ؽƮ  . {/kr}
		m_Info.lpszText = m_szText;
		// {kr} 쿡 ݿ {/kr}
		::SendMessage(m_hwndToolTip, TTM_UPDATETIPTEXT, 0, (LPARAM)(&m_Info));
	}
}

void CNToolTipMgr::SetMargin(LPRECT prcMargin)
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(prcMargin != NULL);
	if(!(prcMargin != NULL)) return;
	
	// {kr}  lazy iniitialize {/kr}
	BOOL bResult = this->_Init();
	// {kr} ϸ ٷ . {/kr}
	if (bResult == FALSE) return;
	
	// {kr}  . {/kr}
	::SendMessage(m_hwndToolTip, TTM_GETMARGIN, 0, (LPARAM)(prcMargin));
}

void CNToolTipMgr::SetPosition( LPPOINT ppt )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(ppt != NULL);
	if(!(ppt != NULL)) return;
	
	// {kr}  lazy iniitialize {/kr}
	BOOL bResult = this->_Init();
	// {kr} ϸ ٷ . {/kr}
	if (bResult == FALSE) return;

	// {kr} 콺 ǥ ppt Է¹޾ 쿡 Ʈŷ {/kr}
	::SendMessage(m_hwndToolTip, TTM_TRACKPOSITION, 0, (LPARAM)(MAKELONG(ppt->x, ppt->y)));
}

void CNToolTipMgr::Update()
{
	// {kr}  lazy iniitialize {/kr}
	BOOL bResult = this->_Init();
	// {kr} ϸ ٷ . {/kr}
	if (bResult == FALSE) return;

	// {kr} ؽƮ   Ʈ  ʿ䰡 Ƿ ٷ . {/kr}
	if (m_Info.lpszText == NULL) return;

	// {kr} ؽƮ Ʈ {/kr}
	::SendMessage(m_hwndToolTip, TTM_UPDATETIPTEXT, (WPARAM)(TRUE), (LPARAM)(&m_Info));
}

void CNToolTipMgr::SetVisible(INToolTip* pToolTip, BOOL bVisible)
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(pToolTip != NULL);
	if(!(pToolTip != NULL)) return;

	// {kr}  lazy iniitialize {/kr}
	BOOL bResult = this->_Init();
	// {kr} ϸ ٷ . {/kr}
	if (bResult == FALSE) return;

	if ( m_pToolTipCurrent != NULL )
	{
		// {kr} ο Ʈѷ     {/kr}
		if (pToolTip != m_pToolTipCurrent)
		{
			// {kr}  show Ϸ ϸ鼭 {/kr}
			if (bVisible == TRUE)
			{
				// {kr}  Ʈ hide Ŵ. {/kr}
				m_pToolTipCurrent->SetVisible(FALSE);
			}
			// {kr}  unvisible ϰ {/kr}
			else
			{
				// {kr}  visible ϴٸ {/kr}
				if (m_pToolTipCurrent->IsVisible() == TRUE)
				{
					// {kr} ٷ  {/kr}
					return;
				}
			}
		}
	}
		
	// {kr}  ȣ Ʈ . {/kr}
	m_pToolTipCurrent = pToolTip;

	// {kr} bVisible   츦 Ȱ/Ȱȭ . {/kr}
	::SendMessage(m_hwndToolTip, TTM_TRACKACTIVATE, (WPARAM)(bVisible), (LPARAM)(&m_Info));

	// {kr} visible ° ؼ Ŭ̾Ʈ  . {/kr}
	m_bVisible = bVisible;
}

BOOL CNToolTipMgr::IsVisible()
{
	// {kr}  Ȱȭ  . {/kr}
	return m_bVisible;
}

void CNToolTipMgr::SetParent( HWND hwndParent )
{
	// {kr} Է° ȿ ˻ {/kr}
	ATLASSERT(::IsWindow(hwndParent) == TRUE);
	if(!(::IsWindow(hwndParent) == TRUE)) return;

	// {kr} θ ڵ  . {/kr}
	m_hwndParent = hwndParent;
}